
#include <stdio.h>
#include "PERT.h"




/* =============== Critical Path Method ================ 

EFT[i]   - Earliest Finish Time for the node i
LFT[i]   - Latest Finish Time for the node i
EST[i]   - Earliest Start Time for the node i
LST[i]   - Latest Start Time for the node i

cp       - critical path

pred[i]  - predecessores do nodo i
in[i]    - grau de entrada do nodo i
ordtop[] - ordenao topolgica
PFT      - Project Finish Time

========================================================= */


Edge *CPM(Graph *g, int EFT[], int LFT[], int EST[], int LST[])
{
  int   in[MAXVERTEX];  
  Edge *pred[MAXVERTEX];
  Edge *p,*e, *cp;
  int   i, j, v, PFT;
  int   ordtop[MAXVERTEX];

  
  // clculo dos predecessores e grau entrada


  // ordenao topolgica 


  // clculo dos "Earliest Start/Finish Times"


  // clculo do "Project Finish Time"


  // clculo dos "Latest Start/Finish Times"


  // clculo do Critical Path


}



// mostra resultados do Critical Path Method
void showCPMresults (Graph *g)
{
  int EFT[MAXVERTEX];
  int LFT[MAXVERTEX];
  int EST[MAXVERTEX];
  int LST[MAXVERTEX];
  Edge *cp, *p;
  int i, pft=0;
  
  cp = CPM(g, EFT, LFT, EST, LST);
  
 
  printf("\n Caminho Critico: \n");
  for (p=cp; p; p=p->next) {
    printf(" %s ",g->task[p->vertex].name);
    pft += g->task[p->vertex].time;
  }

  printf("\n\n Tempo Final do Projecto: %d dias ", pft);

  printf("\n\n Folgas de Tempo nas Tarefas: \n");
  for (i=0; i < g->numV; i++)
    printf(" %s tem %d dias de folga.\n", g->task[i].name, LST[i]-EST[i]);

}
