
#define MAXVERTEX 100
#define MAXNAME   21



// PERT chart  com actividades nos nodos. 

typedef struct edge {
  int          vertex;
  struct edge *next;
} Edge;


typedef struct activity {
  char   name[MAXNAME];          // nome da tarefa
  int    time;                   // durao da tarefa
} Activity;


typedef struct graph {
  int numV;                      // nmero de nodos do grafo
  Activity  task[MAXVERTEX];     // tarefas a executar em cada nodo
  Edge     *adj[MAXVERTEX];      // lista de adjacncia de cada nodo
} Graph; 



// ========= Critical Path Method ======================================= 

Edge *CPM(Graph *g, int EFT[], int LFT[], int EST[], int LST[]);

void showCPMresults (Graph *g);


